using HarmonyLib;
using BepInEx;
using BepInEx.Bootstrap;
using BepInEx.Logging;
using System;
using System.Reflection;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using DiskCardGame;
using UnityEngine;
using InscryptionAPI;
using InscryptionAPI.Saves;
using InscryptionAPI.Card;
using InscryptionAPI.Ascension;
using InscryptionAPI.Helpers;
using InscryptionAPI.Encounters;
using InscryptionAPI.Regions;
using InscryptionAPI.Boons;
using InscryptionAPI.Nodes;
using InscryptionCommunityPatch.Card;
using InscryptionAPI.Triggers;
using System.Globalization;
using Infiniscryption.PackManagement;
using Infiniscryption.P03KayceeRun;

namespace CoolMod;

[BepInPlugin(PluginGuid, PluginName, PluginVersion)]
[BepInDependency("cyantist.inscryption.api", BepInDependency.DependencyFlags.HardDependency)]
[BepInDependency("zorro.inscryption.infiniscryption.p03kayceerun", BepInDependency.DependencyFlags.SoftDependency)]
[BepInDependency("zorro.inscryption.infiniscryption.packmanager", BepInDependency.DependencyFlags.SoftDependency)]
[BepInDependency("arackulele.inscryption.grimoramod", BepInDependency.DependencyFlags.SoftDependency)]
public partial class Plugin : BaseUnityPlugin
{
    // --------------------------------------------------------------------------------------------------------------------------------------------------

    // Declare Harmony here for future Harmony patches. You'll use Harmony to patch the game's code outside of the scope of the API.
    Harmony harmony = new Harmony(PluginGuid);

    // These are variables that exist everywhere in the entire class.
    private const string PluginGuid = "claire.inscryption.coolmod";
    private const string PluginGuid2 = "claire.inscryption.coolmod";
    private const string PluginGuid3 = "claire.inscryption.coolmod";
    private const string PluginGuid4 = "claire.inscryption.coolmod";
    private const string PluginName = "Coolmod";
    private const string PluginVersion = "2.4.0";
    private const string PluginPrefix = "Cool";
    public static string paths;

    public GameObject wings2;
    public AssetBundle wings3;
    public static GameObject wings4;

    public GameObject bottle2;
    public AssetBundle bottle3;

    public static AssetBundle fire3;
    public static GameObject fire4;

    public static GameObject bottle4;
    public static Material Holomat;



    // This is where you would run all of your other methods.
    private void Awake()
    {
        Logger.LogInfo($"Loaded {PluginName}!");

        StarterDeckManager.New(PluginGuid, "WorldBurn", Asset.LoadTexture("fire.png"), new string[] { $"{PluginGuid4}_Phoenix", $"{PluginGuid}_BlackKite", "MudTurtle" });
        StarterDeckManager.New(PluginGuid, "Geophage", Asset.LoadTexture("geolocusts2.png"), new string[] { $"Stump", $"{PluginGuid}_GeoLocusts", "Boulder" });
        StarterDeckManager.New(PluginGuid, "AntsMore", Asset.LoadTexture("antsmore.png"), new string[] { $"{PluginGuid}_Anteater", $"{PluginGuid}_FireAnt", "AntFlying" });
        StarterDeckManager.New(PluginGuid, "Grimiore", Asset.LoadTexture("water.png"), new string[] { $"{PluginGuid}_BottomFeeders", $"Coyote", $"{PluginGuid}_TubeBlenny" });

        if (Chainloader.PluginInfos.ContainsKey("zorro.inscryption.infiniscryption.p03kayceerun"))
        {
            Debug.Log("P03kmod loaded");
            StarterDeckManager.New(PluginGuid, "TechnoMox", Asset.LoadTexture("vessel.png"), new string[] { $"{ PluginGuid4}_HullGuard", $"BustedPrinter", $"{PluginGuid4}_PylonZapper" });
            StarterDeckManager.New(PluginGuid, "TechnoConduit", Asset.LoadTexture("conduit.png"), new string[] { $"{PluginGuid4}_CopperConduit", $"P03KCMXP1_FrankenBot", "P03KCMXP1_ConduitProtector" });
            StarterDeckManager.New(PluginGuid, "TechnoBurn", Asset.LoadTexture("fire2.png"), new string[] { $"{PluginGuid4}_Rioter", $"{PluginGuid4}_Molotov", $"{PluginGuid4}_Pyrotechnic" });
            StarterDeckManager.New(PluginGuid, "TechnoReboot", Asset.LoadTexture("skull.png"), new string[] { $"{PluginGuid4}_SoftwarePirate", $"{PluginGuid}_Librarian", $"P03KCMXP1_Executor" });

            AbilityManager.ModifyAbilityList += delegate (List<AbilityManager.FullAbility> abilities)
            {
                abilities.First(fab => fab.Info.ability == Infiniscryption.P03KayceeRun.Cards.ConduitProtector.AbilityID).Info.SetPixelAbilityIcon(Asset.LoadTexture("pixelconduitprot.png"));
                return abilities;
            };
            AbilityManager.ModifyAbilityList += delegate (List<AbilityManager.FullAbility> abilities)
            {
                abilities.First(fab => fab.Info.ability == Infiniscryption.P03KayceeRun.Cards.CellEvolve.AbilityID).Info.SetPixelAbilityIcon(Asset.LoadTexture("pixelcellevolve.png"));
                return abilities;
            };
            CardLoader.GetCardByName("P03KCMXP1_ConduitProtector").SetPixelPortrait(Asset.LoadTexture("pixelconduitprotector.png"));
            CardManager.ModifyCardList += delegate (List<CardInfo> cards)
            {
                cards.CardByName("P03KCMXP1_ConduitProtector").SetPixelPortrait("pixelconduitprotector.png");
                return cards;
            };
            CardManager.ModifyCardList += delegate (List<CardInfo> cards)
            {
                cards.CardByName("P03KCMXP1_FrankenBot").SetPixelPortrait("pixelfrankenbot.png");
                return cards;
            };
            CardManager.ModifyCardList += delegate (List<CardInfo> cards)
            {
                cards.CardByName("P03KCMXP1_Executor").SetPixelPortrait("pixelexecutor.png");
                return cards;
            };
        }

        // Apply our harmony patches.
        harmony.PatchAll(typeof(Plugin));
        AbilityInfo myInfo = AbilityManager.New(PluginGuid, "Purity", $"if a creature opposes [creature], it's sigils are negated.", typeof(Purity), "pixelconduitprot.png")
        .SetPixelAbilityIcon(Asset.LoadTexture("PurifyPixel.png"));



        
        Add_DavyJones();
        AppendRules();
        Add_Fire();
        Add_Bottomfeeders();
        Add_Executioner();
        Add_GemBomb();
        Add_GemGuard();
        Add_MoxMirage();
        Add_Vessel();
        Add_Enlightened();
        Add_Grandma();
        Add_Wrinkler();
        AppendTransform();
        AppendBloodsucker();
        Add_Guts();
        Add_Coffee();
        Add_Molotov();
        Add_Cerberus();
        Add_TubeBlenny();
        Add_SoftWarePirate();
        Add_FalseMoon();
        Add_ZombieHorde();
        Add_GemSiphon();
        Add_GeoLocusts();
        Add_PylonZapper();
        Add_Necronomicon();
        Add_RollingStone();
        Add_CopperConduit();
        Add_SummonersFamiliar();
        Add_Confectioner();
        Add_Cartographer();
        Add_FaultyMachinery();
        Add_FireAnt();
        Add_Blunderbuster();
        Add_SicklyQueen();
        Add_LochNess();
        Add_StarvingDisciple();
        Add_Anteater();
        Add_BackportAnts();
        Add_HouseMouse();
        Add_LeepbotNeo();
        Add_DrunkMage();
        Add_RebootConduit();
        Add_MellifiedMan();
        Add_Shady();
        Add_Kite();
        AddCustomDeathCard();
        Add_Librarian();

        if (Chainloader.PluginInfos.ContainsKey("zorro.inscryption.infiniscryption.packmanager"))
        {
            CreatePacks();
        }
    }

    public static void CreatePacks()
    {
        PackInfo incrediPack = PackManager.GetPackInfo("claire.inscryption.coolmod");
        incrediPack.Title = "Claire and Gold's Cool Mod for Attractive People";
        incrediPack.SetTexture(TextureHelper.GetImageAsTexture("CAGAMFAPpack.png"));
        incrediPack.Description = "full of cards for all acts of the game.";
        incrediPack.SplitPackByCardTemple = true;
        incrediPack.ValidFor.Add(PackInfo.PackMetacategory.LeshyPack);
        incrediPack.ValidFor.Add(PackInfo.PackMetacategory.P03Pack);
        incrediPack.ValidFor.Add(PackInfo.PackMetacategory.GrimoraPack);
    }

    internal static GameObject dockroom;
    internal static GameObject dockfloor;
    internal static GameObject dockchest;
    internal static GameObject dockobject;

    [HarmonyPatch(typeof(GBC.CameraController), "SetRoom")]
    [HarmonyPostfix]
    public static void Room()
    {
        Debug.Log("setting room");
        if (SceneLoader.ActiveSceneName == "GBC_Temple_Tech")
        {
            Debug.Log("techroom");
            Singleton<GBC.CameraController>.Instance.StartCoroutine(VesselSummon());
        }
        if (SceneLoader.ActiveSceneName == "GBC_Temple_Wizard")
        {
            dockroom = GameObject.Find("Temple");
            dockfloor = dockroom.transform.FindChild("Floor_3").gameObject;
            dockobject = dockfloor.transform.FindChild("Objects").gameObject;
            dockchest = dockobject.transform.FindChild("Chest_Card").gameObject;
            GameObject tempchest = Instantiate(dockchest);
            tempchest.gameObject.GetComponent<GBC.GainSingleCards>().cards.Clear();
            tempchest.gameObject.GetComponent<GBC.GainSingleCards>().cards.Add(CardLoader.GetCardByName($"{PluginGuid}_Vessel"));
            tempchest.transform.FindChild("Sprite").GetComponent<SpriteRenderer>().enabled = false;
            tempchest.transform.position = new Vector3(0, 99f, 0);
            tempchest.transform.FindChild("ContainerVolume").transform.gameObject.GetComponent<GBC.ContainerVolume>().textLines.Clear();
            tempchest.transform.FindChild("ContainerVolume").transform.gameObject.GetComponent<GBC.ContainerVolume>().textLines.Add("though not in the best condition, it appears completely operational.");
            tempchest.name = "tempchest";
        
            DontDestroyOnLoad(tempchest);
            Debug.Log(dockchest);
            if (SceneLoader.PreviousSceneName == "GBC_Temple_Tech")
            {
                SceneLoader.Load("GBC_Temple_Tech");
            }
        }
    }
    public static IEnumerator VesselSummon()
    {
        if (SceneLoader.PreviousSceneName != "GBC_Temple_Wizard")
        {
            SceneLoader.Load("GBC_Temple_Wizard");
        }

        Debug.Log("summoningvessels");
        Debug.Log(GameObject.Find("tempchest"));
        GameObject tempchest2 = Instantiate(GameObject.Find("tempchest"));
        tempchest2.transform.position = new Vector3(8.839f, 0.6986f, 0f);

        GameObject tempchest3 = Instantiate(GameObject.Find("tempchest"));
        tempchest3.transform.position = new Vector3(9.064f, 0.7513f, 0f);

        GameObject tempchest4 = Instantiate(GameObject.Find("tempchest"));
        tempchest4.transform.position = new Vector3(9.7728f, 9.6998f, 0f);

        GameObject tempchest5 = Instantiate(GameObject.Find("tempchest"));
        tempchest5.transform.position = new Vector3(1.0612f, 10.7191f, 0f);

        yield return null;

    }
}
