using DiskCardGame;
using InscryptionAPI.Card;
using InscryptionAPI.Triggers;
using System.Collections;
using UnityEngine;

namespace CoolMod;

public partial class Plugin
{

    private void Add_Anteater()
    {
        StatIconInfo anteater = StatIconManager.New("AntFeast", "Entomophagia", "the value reperesented with this sigil will be equal to double the amount of ants sacrificed to play this card.", typeof(AntFeaster))
            .SetDefaultPart1Ability()
            .SetIcon(Asset.LoadTexture("Entomophagia.png"))
            .SetPixelIcon(Asset.LoadTexture("EntomophagiaPixel.png"));
        anteater.appliesToAttack = true;
        anteater.appliesToHealth = false;
        anteater.gbcDescription = "the power of [creature] is equal to double the amount of ants sacrificed to play it.";
        CardManager.New(modPrefix: PluginGuid, "Anteater", "Anteater", 0, 3, "The Insectivorous Ant Eater, a peculiar diet for a peculiar beast.")
            .SetDefaultPart1Card()
            .SetPortrait(Asset.LoadTexture("AntEater.png"))
            .SetEmissivePortrait(Asset.LoadTexture("AntEaterEmission.png"))
            .SetStatIcon(anteater.iconType)
            .AddAbilities(Ability.MadeOfStone)
            .SetPixelPortrait(Asset.LoadTexture("AntEaterPixel.png"))
            .SetGBCPlayable(CardTemple.Nature)
            .SetBloodCost(3)
            ;
    }
    public class AntFeaster : VariableStatBehaviour
    {
        public override SpecialStatIcon IconType => SpecialStatIcon.Ants;
        int x = 0;
        bool ants1 = false;
        bool ants2 = false;
        bool ants3 = false;
        public override IEnumerator OnOtherCardDrawn(PlayableCard card)
        {
            
            return base.OnOtherCardDrawn(card);
        }
        public override bool RespondsToOtherCardResolve(PlayableCard otherCard) => true;
        public override bool RespondsToOtherCardDie(PlayableCard card, CardSlot deathSlot, bool fromCombat, PlayableCard killer) => true;
        public override bool RespondsToResolveOnBoard() => true;
        public override bool RespondsToUpkeep(bool playerUpkeep) => true;
        public override IEnumerator OnResolveOnBoard()
        {
            if (ants1)
            {
                x+=2;
            }
            if (ants2)
            {
                x+=2;
            }
            if (ants3)
            {
                x+=2;
            }
            ants1 = false;
            ants2 = false;
            ants3 = false;
            return base.OnResolveOnBoard();
        }
        public override IEnumerator OnOtherCardDie(PlayableCard card, CardSlot deathSlot, bool fromCombat, PlayableCard killer)
        {
            if (card.HasTrait(Trait.Ant) && !fromCombat && killer == null)
            {
                if (!ants1) { ants1 = true; } else 
                {
                    if (!ants2) { ants2 = true; } else
                    {
                        if (!ants3) { ants3 = true; }
                    }
                }
            }
            return base.OnOtherCardDie(card, deathSlot, fromCombat, killer);
        }
        public override IEnumerator OnUpkeep(bool playerUpkeep)
        {
            ants1 = false;
            ants2 = false;
            ants3 = false;
            return base.OnUpkeep(playerUpkeep);
        }
        public override IEnumerator OnOtherCardResolve(PlayableCard otherCard)
        {
            ants1 = false;
            ants2 = false;
            ants3 = false;
            return base.OnOtherCardResolve(otherCard);
        }
        public override int[] GetStatValues()
        {
            int[] array = new int[2];
            array[0] = x;
            return array;
        }
    }
}