using DiskCardGame;
using InscryptionAPI.Card;
using UnityEngine;

namespace CoolMod;

public partial class Plugin
{
    private void Add_BackportAnts()
    {
        CardManager.BaseGameCards.CardByName("Ant")
            .AddMetaCategories(CardMetaCategory.GBCPack, CardMetaCategory.GBCPlayable)
            .SetPixelPortrait("Workerantpixel.png")
            ;
        CardManager.BaseGameCards.CardByName("AntQueen").
            AddMetaCategories(CardMetaCategory.GBCPack, CardMetaCategory.GBCPlayable)
            .SetPixelPortrait("pixelportrait_antqueen.png")
            ;
        CardManager.BaseGameCards.CardByName("AntFlying").AddMetaCategories(CardMetaCategory.GBCPack, CardMetaCategory.GBCPlayable);
        CardManager.BaseGameCards.CardByName("CellBuff")
            .SetGBCPlayable(CardTemple.Tech)
            .SetPixelPortrait("buffcell.png")
            ;
        CardManager.BaseGameCards.CardByName("LatcherShield")
            .SetGBCPlayable(CardTemple.Tech)
            .SetPixelPortrait("shieldlatch.png")
            ;
        CardManager.BaseGameCards.CardByName("XformerPorcupineBot")
            .SetGBCPlayable(CardTemple.Tech)
            .SetPixelPortrait("porcupinebotquill.png")
            ;
        CardManager.New(modPrefix: PluginGuid2, "Privateer", "Privateer", 1, 1, "")
            .SetPortrait(Asset.LoadTexture("portrait_fire.png"))
            .SetEmissivePortrait(Asset.LoadTexture("portrait_fire.png"))
            .AddAbilities(Ability.Sniper, Anchor.ability)
            .SetPixelPortrait(Asset.LoadTexture("privateer.png"))
            .SetGBCPlayable(CardTemple.Undead)
            .SetBonesCost(4)
            ;
    }
    private void AddCustomDeathCard()
    {
        CardModificationInfo deathCardMod = new CardModificationInfo(2, 2)
            .SetNameReplacement("Gold")
            .SetSingletonId("Gold")
            .SetBonesCost(4)
            .AddAbilities(InverseFireman.ability, Molotov2.ability)
            .SetAttackAndHealth(2,4)
            .SetDeathCardPortrait(CompositeFigurine.FigurineType.SettlerWoman, 4, 7, true);
        CardModificationInfo deathCardMod2 = new CardModificationInfo(2, 2)
            .SetNameReplacement("Claire")
            .SetSingletonId("Claire")
            .SetBloodCost(3)
            .AddAbilities(Purity.ability)
            .SetAttackAndHealth(5, 5)
            .SetDeathCardPortrait(CompositeFigurine.FigurineType.Enchantress, 0, 5, true);

        // you can then add your newly created death card to the list of default death card mods like so
        DeathCardManager.AddDefaultDeathCard(deathCardMod);
        DeathCardManager.AddDefaultDeathCard(deathCardMod2);
    }
}