using DiskCardGame;
using GBC;
using InscryptionAPI.Card;
using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

namespace CoolMod;

public partial class Plugin
{
    private void Add_Kite()
    {
        Texture2D tex = Asset.LoadTexture("PyromaniaPixel.png");
        Sprite texSprite1 = Sprite.Create(tex, new Rect(0.0f, 0.0f, tex.width, tex.height), new Vector2(0.5f, 0.5f), 100.0f);

        AbilityInfo Pyromania = AbilityManager.New(
        PluginGuid,
        "Pyromania",
        "spend 3 bones to create a fire card in a chosen space.",
        typeof(Kite),
        Asset.LoadTexture("Pyromania.png")
    );
        Pyromania.pixelIcon = texSprite1;
        Pyromania.powerLevel = 4;
        Pyromania.activated = true;
        Pyromania.SetDefaultPart1Ability();

        Kite.ability = Pyromania.ability;
        CardManager.New(modPrefix: PluginGuid, "BlackKite", "Black Kite", 2, 2, "Some creatures just want to watch the world burn.")
            .SetPortrait(Asset.LoadTexture("portrait_BlackKite.png"))
            .SetEmissivePortrait(Asset.LoadTexture("BlackKiteEmission.png"))
            .AddAbilities(Pyromania.ability)
            .SetPixelPortrait(Asset.LoadTexture("BlackKite.png"))
            .SetGBCPlayable(CardTemple.Nature)
            .SetBloodCost(2)
            .AddTribes(Tribe.Bird)
            ;
    }
    public class Kite : ExtendedActivatedAbilityBehaviour
    {
        List<CardSlot> emptyslots = new List<CardSlot>();
        internal static Ability ability;
        public override Ability Ability => ability;
        public override int StartingBonesCost => 3;
        public override bool CanActivate() => true;
        public override IEnumerator Activate()
        {
            List<CardSlot> emptyslots = new List<CardSlot>();
            for (int i = 0; i < BoardManager.Instance.allSlots.Count; i++)
            {
                if (BoardManager.Instance.allSlots[i].Card == null)
                {
                    emptyslots.Add(BoardManager.Instance.allSlots[i]);
                }
            }
            Debug.Log("pressed");
            Action<CardSlot> healer = i => this.StartCoroutine(heal(i));
            Func<bool> result = new Func<bool>(() => false);
            IEnumerator heal(CardSlot cardslot)
            {
                if (cardslot.Card == null)
                {
                    if (Singleton<TextBox>.Instance != null)
                    {
                        yield return Singleton<TextBox>.Instance.ShowUntilInput(Card.Info.displayedName + " watched the world burn!", TextBox.Style.Neutral);
                    }
                    yield return BoardManager.Instance.CreateCardInSlot(CardLoader.GetCardByName($"{PluginGuid}_Fire"), cardslot);
                }
                Debug.Log(cardslot);
                yield break;
            }
            if (emptyslots.Count > 0)
            {
                yield return Singleton<BoardManager>.Instance.ChooseTarget(emptyslots, emptyslots, healer, null, null, result, CursorType.Target);
            }
            yield break;
        }
        public CardModificationInfo Healer
        {
            get
            {
                CardModificationInfo info = new CardModificationInfo() { healthAdjustment = 3 };
                return info;
            }

        }
    }
}