using DiskCardGame;
using InscryptionAPI.Card;
using InscryptionAPI.Triggers;
using System.Collections;
using System.Collections.Generic;

namespace CoolMod;

public partial class Plugin
{
    private void Add_Blunderbuster()
    {
        AbilityInfo blunderbust = AbilityManager.New(PluginGuid, "Blunder Buster", $"[creature] attacks forward, as well as doing half damage diagonally", typeof(Blunderbuststrike), "Spreadshot.png")
        .SetPixelAbilityIcon(Asset.LoadTexture("SpreadshotPixel.png"))
        ;
        CardInfo cardInfo = CardManager.New(modPrefix: PluginGuid2, "GrimoraMod_Blunderbuster", "Blunderbuster", 2, 3, " Inaccurate, heavy recoil, but ill be damned if it doesnt hurt! ")
            .SetDefaultPart3Card()
            .SetPortrait(Asset.LoadTexture("BlunderBuster.png"))
            .SetEmissivePortrait(Asset.LoadTexture("BlunderBusterEmission.png"))
            .AddAbilities(blunderbust.ability)
            .SetPixelPortrait(Asset.LoadTexture("BlunderBusterPixel.png"))
            .SetGBCPlayable(CardTemple.Undead)
            .SetBonesCost(7)
            ;
        CardManager.Add("arackulele.inscryption.grimoramod", cardInfo);
    }
    public class Blunderbuststrike : AbilityBehaviour, IGetOpposingSlots, IOnPreSlotAttackSequence, IPassiveAttackBuff, IOnPostSingularSlotAttackSlot
    {
        public override Ability Ability => Ability;
        public bool RespondsToGetOpposingSlots() => true;
        public override bool RespondsToUpkeep(bool playerUpkeep) => true;
        public bool RemoveDefaultAttackSlot() => false;
        public List<CardSlot> GetOpposingSlots(List<CardSlot> originalSlots, List<CardSlot> otherAddedSlots)
        {
            List<CardSlot> slotsToTarget = new List<CardSlot>() { BoardManager.Instance.GetAdjacentSlots(Card.OpposingSlot())[0], BoardManager.Instance.GetAdjacentSlots(Card.OpposingSlot())[1]};
            return slotsToTarget;
        }
        int halved = 0;
        public bool RespondsToPreSlotAttackSequence(CardSlot attackingSlot) => true;
        public IEnumerator OnPreSlotAttackSequence(CardSlot attackingSlot)
        {
            halved = -Card.Attack / 2;
            return null;
        }
        public override IEnumerator OnUpkeep(bool playerUpkeep)
        {
            if (playerUpkeep)
            {
                halved = 0;
                slottargetting = 0;
            }
            return null;
        }
        int IPassiveAttackBuff.GetPassiveAttackBuff(PlayableCard target) => Card.OnBoard && target.Info == Card.Info ? halved : 0;
        public bool RespondsToPostSingularSlotAttackSlot(CardSlot attackingSlot, CardSlot targetSlot) => true;
        int slottargetting = 0;
        public IEnumerator OnPostSingularSlotAttackSlot(CardSlot attackingSlot, CardSlot targetSlot)
        {
            slottargetting++;
            if (slottargetting == 1)
            {
                halved = 0;
            }
            if (slottargetting == 2)
            {
                halved = -Card.Attack / 2;
            }
            if (slottargetting == 3)
            {
                halved = 0;
            }
            return null;
        }
    }
}