using DiskCardGame;
using InscryptionAPI.Card;

namespace CoolMod;

public partial class Plugin
{
    private void Add_Cerberus()
    {
        CardManager.New(modPrefix: PluginGuid, "Cerberus", "Cerberus", 3, 3, "Cerberus, Guardian of Hell, none get past this guardian of the depths.")
            .SetDefaultPart1Card()
            .SetPortrait(Asset.LoadTexture("Cerberus.png"))
            .SetEmissivePortrait(Asset.LoadTexture("CerberusEmission.png"))
            .AddAbilities(Ability.TriStrike, Ability.GuardDog)
            .SetPixelPortrait(Asset.LoadTexture("CerberusPixel.png"))
            .SetGBCPlayable(CardTemple.Nature)
            .AddMetaCategories(CardMetaCategory.Rare)
            .SetRare()
            .SetBloodCost(3);
            ;
    }
    private void Add_TubeBlenny()
    {
        CardManager.New(modPrefix: PluginGuid, "TubeBlenny", "Tube Blenny", 0, 1, "The territorial blenny, refuting any attempts into its home.")
            .SetDefaultPart1Card()
            .SetPortrait(Asset.LoadTexture("TubeBlenny.png"))
            .SetEmissivePortrait(Asset.LoadTexture("TubeBlennyEmission.png"))
            .AddAbilities(Ability.Submerge, SentrySubmerge.ability)
            .SetPixelPortrait(Asset.LoadTexture("TubeeBlennyPixel.png"))
            .SetGBCPlayable(CardTemple.Nature)
            .AddMetaCategories(CardMetaCategory.ChoiceNode, CardMetaCategory.TraderOffer)
            .SetBloodCost(1);
        ;
    }
    private void Add_SoftWarePirate()
    {
        CardManager.New(modPrefix: PluginGuid4, "SoftwarePirate", "Software Pirate", 1, 2, "")
            .SetDefaultPart3Card()
            .SetPortrait(Asset.LoadTexture("SoftwarePirate.png"))
            .SetEmissivePortrait(Asset.LoadTexture("SoftwarePirate.png"))
            .AddAbilities(LootersDraw.ability, Anchor.ability)
            .SetPixelPortrait(Asset.LoadTexture("SoftwarePiratePixel.png"))
            .SetGBCPlayable(CardTemple.Tech)
            .AddMetaCategories(CardMetaCategory.ChoiceNode, CardMetaCategory.TraderOffer, DeathRegion)
            .SetEnergyCost(5)
        ;
        
    }
    private void Add_FalseMoon()
    {
        CardManager.New(modPrefix: PluginGuid, "FalseMoon", "False Moon", 1, 5, "")
            .SetDefaultPart3Card()
            .SetPortrait(Asset.LoadTexture("FalseMoon.png"))
            .SetEmissivePortrait(Asset.LoadTexture("FalseMoon.png"))
            .AddAbilities(Ability.AllStrike)
            .SetPixelPortrait(Asset.LoadTexture("FalseMoonPixel.png"))
            .SetGBCPlayable(CardTemple.Tech)
            .AddMetaCategories(CardMetaCategory.ChoiceNode, CardMetaCategory.TraderOffer, BeastRegion)
            .SetEnergyCost(6)
            .SetRare();
        ;
    }
}