using DiskCardGame;
using GBC;
using InscryptionAPI.Card;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

namespace CoolMod;

public partial class Plugin
{
    private void Add_Coffee()
    {

        AbilityInfo myInfo = AbilityManager.New(PluginGuid, "Purity", $"if a creature opposes [creature], it's sigils are negated.", typeof(Purity), "Purity.png")
        .SetPixelAbilityIcon(Asset.LoadTexture("PurifyPixel.png"))
        .SetDefaultPart1Ability();
        Purity.ability = myInfo.ability;
        SpecialTriggeredAbility Special = SpecialTriggeredAbilityManager.Add(PluginGuid, "Special", typeof(Blunt)).Id;

    CardManager.New(modPrefix: PluginGuid3, "CoffeeMage", "Coffee Mage", 1, 1, " ")
            .SetDefaultPart3Card()
            .SetPortrait(Asset.LoadTexture("portrait_bottomfeeder.png"))
            .SetEmissivePortrait(Asset.LoadTexture("portrait_bottomfeeder_emission.png"))
            .AddAbilities(myInfo.ability)
            .SetPixelPortrait(Asset.LoadTexture("CoffeeMage.png"))
            .SetGBCPlayable(CardTemple.Wizard)
            .SetCost(gemsCost: new List<GemType> { GemType.Blue })
            .metaCategories.Add(CardMetaCategory.GBCPack)
        ;
    CardInfo cardInfo = CardManager.New(modPrefix: PluginGuid2, "Excorcist", "Excorcist", 1, 3, "Attempts to purge spirits rarely return positive.")
            .SetDefaultPart3Card()
            .SetPortrait(Asset.LoadTexture("Exorcist.png"))
            .SetEmissivePortrait(Asset.LoadTexture("ExorcistEmission.png"))
            .AddAbilities(myInfo.ability)
            .SetPixelPortrait(Asset.LoadTexture("ExorcistPixel.png"))
            .SetGBCPlayable(CardTemple.Undead)
            .SetBonesCost(6)
        ;

        CardManager.Add("arackulele.inscryption.grimoramod", cardInfo);

    }
    public class Blunt : AbilityBehaviour
    {
        public override Ability Ability => Ability;
        public override bool RespondsToDrawn() => true;
        public override IEnumerator OnDrawn()
        {

                Debug.Log("coffee");

            return base.OnDrawn();
        }
    }
    public class Purity : AbilityBehaviour
    {
        internal static Ability ability;
        public override Ability Ability => ability;
        bool alreadydone = false;
        public override bool RespondsToOtherCardAssignedToSlot(PlayableCard otherCard)
        {
            if (Card.OpposingSlot().Card != null)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        public override bool RespondsToResolveOnBoard()
        {
            if (Card.OpposingSlot().Card != null)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        public override IEnumerator OnUpkeep(bool playerupkeep)
        {
            Debug.Log("upkept");
            if (!Card.OpposingSlot().Card.TemporaryMods.Contains(Negate))
            {
                Card.slot.opposingSlot.Card.AddTemporaryMod(Negate);
                StartCoroutine(CoolFlip());
            }
            return base.OnTurnEnd(playerupkeep);
        }
        public override IEnumerator OnResolveOnBoard()
        {
            Debug.Log("resolve");
            if (!Card.OpposingSlot().Card.TemporaryMods.Contains(Negate))
            {
                AudioController.Instance.PlaySound2D("magnificus_brush_splatter_bleach", MixerGroup.None, 0.5f, 0f, null, null, null, null, false);
                Card.slot.opposingSlot.Card.AddTemporaryMod(Negate);
                StartCoroutine(CoolFlip());
            }

            return base.OnResolveOnBoard();
        }
        public override IEnumerator OnOtherCardAssignedToSlot(PlayableCard otherCard)
        {
            Debug.Log("assigned");
            if (otherCard.slot == Card.OpposingSlot())
            {
                alreadydone = false;
            }
            if (!Card.OpposingSlot().Card.TemporaryMods.Contains(Negate) && !alreadydone)
            {
                alreadydone = true;
                AudioController.Instance.PlaySound2D("magnificus_brush_splatter_bleach", MixerGroup.None, 0.5f, 0f, null, null, null, null, false);
                Card.slot.opposingSlot.Card.AddTemporaryMod(Negate);
            }
            yield return base.OnOtherCardAssignedToSlot(otherCard);
        }
        public CardModificationInfo Negate
        {
            get
            {
                CardModificationInfo info = new CardModificationInfo() { negateAbilities = new List<Ability>() };
                if (Card.OpposingSlot().Card.TemporaryMods != null)
                {
                    foreach (CardModificationInfo info2 in Card.OpposingSlot().Card.TemporaryMods) { 
                        info.negateAbilities.AddRange(info2.abilities);
                    }
                }
                if (Card.OpposingSlot().Card.Info.Abilities != null)
                {
                    info.negateAbilities.AddRange(Card.OpposingSlot().Card.Info.Abilities);
                }
                return info;
            }
        }
        public IEnumerator CoolFlip() {
            if (!Card.OpposingSlot().Card.TemporaryMods.Contains(Negate))
            {
                Card.slot.opposingSlot.Card.SetFaceDown(true);
                yield return new WaitForSeconds(0.4f);
                Card.slot.opposingSlot.Card.SetFaceDown(false);
                yield return Singleton<TextBox>.Instance.ShowUntilInput(Card.Info.displayedName + " nullified "+ Card.OpposingCard().Info.displayedName + "!", TextBox.Style.Neutral);
                yield return null;
            }
        }
    }
}