using DiskCardGame;
using InscryptionAPI.Card;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

namespace CoolMod;

public partial class Plugin
{
    private void Add_Confectioner()
    {
        AbilityInfo confectioner = AbilityManager.New(PluginGuid3, "Rock Candy", $"while [creature] is in play, all mox cards are replaced by confections which yield those gems and can be sacrificed.", typeof(Confections), "RockCandy.png")
        .SetPixelAbilityIcon(Asset.LoadTexture("RockCandyPixel.png"))
        ;
        CardManager.New(modPrefix: PluginGuid, "Confectioner", "Confectioner", 0, 2, "")
            .SetPortrait(Asset.LoadTexture("portrait_fire.png"))
            .SetEmissivePortrait(Asset.LoadTexture("portrait_fire.png"))
            .AddAbilities(confectioner.ability)
            .SetPixelPortrait(Asset.LoadTexture("Confectioner.png"))
            .SetGBCPlayable(CardTemple.Wizard)
            .SetCost(gemsCost: new List<GemType> { GemType.Green })
            ;
        CardManager.New(modPrefix: PluginGuid3, "SapphireTreat", "Sapphire Sweets", 0, 1, "")
            .AddAbilities(Ability.GainGemBlue)
            .AddTraits(Trait.Gem)
            .SetPixelPortrait(Asset.LoadTexture("treatsapphire.png"))
            ;
        CardManager.New(modPrefix: PluginGuid3, "RubyTreat", "Ruby Pop", 0, 1, "")
            .AddAbilities(Ability.GainGemOrange)
            .AddTraits(Trait.Gem)
            .SetPixelPortrait(Asset.LoadTexture("treatruby.png"))
            ;
        CardManager.New(modPrefix: PluginGuid3, "EmeraldTreat", "Emerald Candies", 0, 1, "")
            .AddAbilities(Ability.GainGemGreen)
            .AddTraits(Trait.Gem)
            .SetPixelPortrait(Asset.LoadTexture("treatemerald.png"))
            ;
        CardManager.New(modPrefix: PluginGuid3, "OrluTreat", "Orlu's Ringpop", 0, 2, "")
            .AddAbilities(Ability.GainGemBlue, Ability.GainGemOrange)
            .AddTraits(Trait.Gem)

            .SetPixelPortrait(Asset.LoadTexture("treatorlu.png"))
            ;
        CardManager.New(modPrefix: PluginGuid3, "GoranjTreat", "Goranj's Cookies", 0, 2, "")
            .AddAbilities(Ability.GainGemOrange, Ability.GainGemGreen)
            .AddTraits(Trait.Gem)

            .SetPixelPortrait(Asset.LoadTexture("treatgoranj.png"))
            ;
        CardManager.New(modPrefix: PluginGuid3, "BleeneTreat", "Bleene's Jawbreaker", 0, 2, "")
            .AddAbilities(Ability.GainGemGreen, Ability.GainGemBlue)
            .AddTraits(Trait.Gem)

            .SetPixelPortrait(Asset.LoadTexture("treatbleene.png"))
            ;

        CardManager.New(modPrefix: PluginGuid3, "RollingTreat", "Roll Up", 0, 1, "")
            .AddAbilities(Ability.GainGemGreen, Rolling.ability)
            .AddTraits(Trait.Gem)
            .SetPixelPortrait(Asset.LoadTexture("treatrollup.png"))
            ;
        CardManager.New(modPrefix: PluginGuid3, "PrismTreat", "Prism Candies", 0, 3, "")
            .AddAbilities(Ability.MadeOfStone)
            .AddTraits(Trait.Gem)
            .SetPixelPortrait(Asset.LoadTexture("treatprism.png"))
            ;
    }
    public class Confections : AbilityBehaviour
    {
        public override Ability Ability => Ability;
        public override bool RespondsToResolveOnBoard() => true;
        public override bool RespondsToOtherCardResolve(PlayableCard otherCard) => true;
        public override bool RespondsToUpkeep(bool playerUpkeep) => true;
        public override IEnumerator OnResolveOnBoard()
        {
            for (int i = 0; i < BoardManager.Instance.playerSlots.Count; i++)
            {
                if (BoardManager.Instance.playerSlots[i].Card != null)
                {
                    if (BoardManager.Instance.playerSlots[i].Card.HasTrait(Trait.Gem) && BoardManager.Instance.playerSlots[i].Card.HasTrait(Trait.Terrain))
                    {
                        if (BoardManager.Instance.playerSlots[i].Card.Info.displayedName == "Sapphire Mox")
                        {
                            yield return BoardManager.Instance.playerSlots[i].Card.TakeDamage(333, null);
                            yield return BoardManager.Instance.CreateCardInSlot(CardLoader.GetCardByName($"{PluginGuid}_SapphireTreat"), BoardManager.Instance.playerSlots[i]);
                        }
                        else
                        {
                            if (BoardManager.Instance.playerSlots[i].Card.Info.displayedName == "Ruby Mox")
                            {
                                yield return BoardManager.Instance.playerSlots[i].Card.TakeDamage(333, null);
                                yield return BoardManager.Instance.CreateCardInSlot(CardLoader.GetCardByName($"{PluginGuid}_RubyTreat"), BoardManager.Instance.playerSlots[i]);
                            }
                            else
                            {
                                if (BoardManager.Instance.playerSlots[i].Card.Info.displayedName == "Emerald Mox")
                                {
                                    yield return BoardManager.Instance.playerSlots[i].Card.TakeDamage(333, null);
                                    yield return BoardManager.Instance.CreateCardInSlot(CardLoader.GetCardByName($"{PluginGuid}_EmeraldTreat"), BoardManager.Instance.playerSlots[i]);
                                }
                                else
                                {
                                    if (BoardManager.Instance.playerSlots[i].Card.Info.displayedName == "Bleene's Mox")
                                    {
                                        yield return BoardManager.Instance.playerSlots[i].Card.TakeDamage(333, null);
                                        yield return BoardManager.Instance.CreateCardInSlot(CardLoader.GetCardByName($"{PluginGuid}_BleeneTreat"), BoardManager.Instance.playerSlots[i]);
                                    }
                                    else
                                    {
                                        if (BoardManager.Instance.playerSlots[i].Card.Info.displayedName == "Goranj's Mox")
                                        {
                                            yield return BoardManager.Instance.playerSlots[i].Card.TakeDamage(333, null);
                                            yield return BoardManager.Instance.CreateCardInSlot(CardLoader.GetCardByName($"{PluginGuid}_GoranjTreat"), BoardManager.Instance.playerSlots[i]);
                                        }
                                        else
                                        {
                                            if (BoardManager.Instance.playerSlots[i].Card.Info.displayedName == "Orlu's Mox")
                                            {
                                                yield return BoardManager.Instance.playerSlots[i].Card.TakeDamage(333, null);
                                                yield return BoardManager.Instance.CreateCardInSlot(CardLoader.GetCardByName($"{PluginGuid}_OrluTreat"), BoardManager.Instance.playerSlots[i]);
                                            }
                                            else
                                            {
                                                if (BoardManager.Instance.playerSlots[i].Card.Info.displayedName == "Rolling Stone")
                                                {
                                                    yield return BoardManager.Instance.playerSlots[i].Card.TakeDamage(333, null);
                                                    yield return BoardManager.Instance.CreateCardInSlot(CardLoader.GetCardByName($"{PluginGuid}_RollingTreat"), BoardManager.Instance.playerSlots[i]);
                                                }
                                                else
                                                {
                                                    yield return BoardManager.Instance.playerSlots[i].Card.TakeDamage(333, null);
                                                    yield return BoardManager.Instance.CreateCardInSlot(CardLoader.GetCardByName($"{PluginGuid}_PrismTreat"), BoardManager.Instance.playerSlots[i]);
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            yield return base.OnResolveOnBoard();
        }
        public override IEnumerator OnOtherCardResolve(PlayableCard otherCard)
        {
            for (int i = 0; i < BoardManager.Instance.playerSlots.Count; i++)
            {
                if (BoardManager.Instance.playerSlots[i].Card != null)
                {
                    if (BoardManager.Instance.playerSlots[i].Card.HasTrait(Trait.Gem) && BoardManager.Instance.playerSlots[i].Card.HasTrait(Trait.Terrain))
                    {
                        if (BoardManager.Instance.playerSlots[i].Card.Info.displayedName == "Sapphire Mox")
                        {
                            yield return BoardManager.Instance.playerSlots[i].Card.TakeDamage(333, null);
                            yield return BoardManager.Instance.CreateCardInSlot(CardLoader.GetCardByName($"{PluginGuid}_SapphireTreat"), BoardManager.Instance.playerSlots[i]);
                        }
                        else
                        {
                            if (BoardManager.Instance.playerSlots[i].Card.Info.displayedName == "Ruby Mox")
                            {
                                yield return BoardManager.Instance.playerSlots[i].Card.TakeDamage(333, null);
                                yield return BoardManager.Instance.CreateCardInSlot(CardLoader.GetCardByName($"{PluginGuid}_RubyTreat"), BoardManager.Instance.playerSlots[i]);
                            }
                            else
                            {
                                if (BoardManager.Instance.playerSlots[i].Card.Info.displayedName == "Emerald Mox")
                                {
                                    yield return BoardManager.Instance.playerSlots[i].Card.TakeDamage(333, null);
                                    yield return BoardManager.Instance.CreateCardInSlot(CardLoader.GetCardByName($"{PluginGuid}_EmeraldTreat"), BoardManager.Instance.playerSlots[i]);
                                }
                                else
                                {
                                    if (BoardManager.Instance.playerSlots[i].Card.Info.displayedName == "Bleene's Mox")
                                    {
                                        yield return BoardManager.Instance.playerSlots[i].Card.TakeDamage(333, null);
                                        yield return BoardManager.Instance.CreateCardInSlot(CardLoader.GetCardByName($"{PluginGuid}_BleeneTreat"), BoardManager.Instance.playerSlots[i]);
                                    }
                                    else
                                    {
                                        if (BoardManager.Instance.playerSlots[i].Card.Info.displayedName == "Goranj's Mox")
                                        {
                                            yield return BoardManager.Instance.playerSlots[i].Card.TakeDamage(333, null);
                                            yield return BoardManager.Instance.CreateCardInSlot(CardLoader.GetCardByName($"{PluginGuid}_GoranjTreat"), BoardManager.Instance.playerSlots[i]);
                                        }
                                        else
                                        {
                                            if (BoardManager.Instance.playerSlots[i].Card.Info.displayedName == "Orlu's Mox")
                                            {
                                                yield return BoardManager.Instance.playerSlots[i].Card.TakeDamage(333, null);
                                                yield return BoardManager.Instance.CreateCardInSlot(CardLoader.GetCardByName($"{PluginGuid}_OrluTreat"), BoardManager.Instance.playerSlots[i]);
                                            }
                                            else
                                            {
                                                if (BoardManager.Instance.playerSlots[i].Card.Info.displayedName == "Rolling Stone")
                                                {
                                                    yield return BoardManager.Instance.playerSlots[i].Card.TakeDamage(333, null);
                                                    yield return BoardManager.Instance.CreateCardInSlot(CardLoader.GetCardByName($"{PluginGuid}_RollingTreat"), BoardManager.Instance.playerSlots[i]);
                                                }
                                                else
                                                {
                                                    yield return BoardManager.Instance.playerSlots[i].Card.TakeDamage(333, null);
                                                    yield return BoardManager.Instance.CreateCardInSlot(CardLoader.GetCardByName($"{PluginGuid}_PrismTreat"), BoardManager.Instance.playerSlots[i]);
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            yield return base.OnOtherCardResolve(otherCard);
        }
    }
}