using DiskCardGame;
using GBC;
using InscryptionAPI.Card;
using InscryptionAPI.Triggers;
using System.Collections;
using UnityEngine;

namespace CoolMod;

public partial class Plugin
{
    private void Add_CopperConduit()
    {
        AbilityInfo convolesce = AbilityManager.New(PluginGuid, "Convolescence", $"if [creature] completes a circuit, [creature] gains +1 health every turn.", typeof(Convalesce), "Convalesce.png")
            .SetPixelAbilityIcon(Asset.LoadTexture("pixelability_conduithealing.png"))
            .SetDefaultPart3Ability()
            ;
        convolesce.conduit = true;
        CardManager.New(modPrefix: PluginGuid4, "CopperConduit", "Copper Conduit", 0, 1, "")
            .SetDefaultPart3Card()
            .SetPortrait(Asset.LoadTexture("CopperConduit.png"))
            .SetEmissivePortrait(Asset.LoadTexture("CopperConduit.png"))
            .AddAbilities(convolesce.ability)
            .SetPixelPortrait(Asset.LoadTexture("CopperConduitPixel.png"))
            .SetGBCPlayable(CardTemple.Tech)
            .SetEnergyCost(3)
            .AddMetaCategories(TechRegion)
            .HasConduitAbility().Equals(true);
            ;
    }
    public class Convalesce : ConduitNull, IPassiveHealthBuff
    {
        public override Ability Ability => Ability.ConduitNull;
        public override bool RespondsToUpkeep(bool playerUpkeep)
        {
            if (playerUpkeep) { return true; }else { return false; }
        }
        public int x = 0;
        public int GetPassiveHealthBuff(PlayableCard target) => target.Info != Card.Info ? 0 : x;
        public override IEnumerator OnUpkeep(bool playerUpkeep)
        {
            for (int i = 0; i < BoardManager.Instance.playerSlots.Count; i++)
            {
                if (BoardManager.Instance.playerSlots[i].Card != null)
                {
                    if (BoardManager.Instance.playerSlots[i].Card.HasConduitAbility() && BoardManager.Instance.playerSlots[i].Card != Card)
                    {
                        yield return Singleton<TextBox>.Instance.ShowUntilInput(Card.Info.displayedName + " grew bulkier!", TextBox.Style.Neutral);
                        x++;
                    }
                }
            }

        }
    }
}