using DiskCardGame;
using GBC;
using InscryptionAPI.Card;
using InscryptionAPI.Triggers;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

namespace CoolMod;

public partial class Plugin
{
    private void Add_DrunkMage()
    {
        AbilityInfo drunk = AbilityManager.New(PluginGuid3, "Drunk", $"while [creature] is on the field, all cards attack with their health, not their power.", typeof(Drunken), "mixups.png")
        .SetPixelAbilityIcon(Asset.LoadTexture("mixupspixel.png"))
        ;
        CardManager.New(modPrefix: PluginGuid, "DrunkMage", "Drunken Wizard", 0, 1, "")
            .SetPortrait(Asset.LoadTexture("ZombieHorde.png"))
            .SetEmissivePortrait(Asset.LoadTexture("ZombieHordeEmission.png"))
            .AddAbilities(drunk.ability)
            .SetPixelPortrait(Asset.LoadTexture("drunkenwizard.png"))
            .SetGBCPlayable(CardTemple.Wizard)
            .AddMetaCategories(CardMetaCategory.ChoiceNode, CardMetaCategory.TraderOffer)
            .SetCost(gemsCost: new List<GemType> { GemType.Green })
            .AddMetaCategories(CardMetaCategory.GBCPack)
            .SetRare()
            ;
    }
    public class Drunken : AbilityBehaviour, IPassiveAttackBuff
    {
        public override Ability Ability => Ability;
        public int GetPassiveAttackBuff(PlayableCard target) => Card.OnBoard ? target.Health -target.Info.baseAttack-target.GetAttackModifications() : 0;
    }
}