using DiskCardGame;
using GBC;
using InscryptionAPI.Card;
using InscryptionAPI.Triggers;
using System.Collections;
using UnityEngine;

namespace CoolMod;

public partial class Plugin
{
    private void Add_FaultyMachinery()
    {
        Texture2D tex = Asset.LoadTexture("SparkingPixel.png");
        Sprite texSprite1 = Sprite.Create(tex, new Rect(0.0f, 0.0f, tex.width, tex.height), new Vector2(0.5f, 0.5f), 100.0f);

        AbilityInfo toasters = AbilityManager.New(
        PluginGuid,
        "Toasted",
        "sacrifice a creature, a fire card is put in its place",
        typeof(toaster),
        Asset.LoadTexture("Sparking.png")
    );
        toasters.pixelIcon = texSprite1;
        toasters.powerLevel = 4;
        toasters.activated = true;
        toaster.ability = toasters.ability;
        toasters.rulebookName = "Sparking";

        CardManager.New(modPrefix: PluginGuid4, "FaultyMachinery", "Faulty Machinery", 1, 2, "")
            .SetDefaultPart3Card()
            .SetPortrait(Asset.LoadTexture("Faulty_Machinery.png"))
            .SetEmissivePortrait(Asset.LoadTexture("Faulty_Machinery.png"))
            .AddAbilities(toasters.ability)
            .SetPixelPortrait(Asset.LoadTexture("FaultyMachinery.png"))
            .SetGBCPlayable(CardTemple.Tech)
            .SetEnergyCost(4)
            .AddMetaCategories(DeathRegion)
            ;
    }
    public class toaster : ExtendedActivatedAbilityBehaviour
    {
        internal static Ability ability;
        public override Ability Ability => ability;
        public override int StartingBloodCost => 1;
        public override bool CanActivate() => true;
        public override bool RespondsToOtherCardDie(PlayableCard card, CardSlot deathSlot, bool fromCombat, PlayableCard killer) => true;
        CardSlot slot = null;
        public override IEnumerator Activate()
        {
            yield return BoardManager.Instance.CreateCardInSlot(CardLoader.GetCardByName($"{PluginGuid}_Fire"), slot);
            yield return Singleton<TextBox>.Instance.ShowUntilInput(Card.Info.displayedName + " failed to make toast!", TextBox.Style.Neutral);
            Singleton<InteractionCursor>.Instance.ClearForcedCursorType();
            Debug.Log("pressed");
            yield break;
        }
        public override IEnumerator OnOtherCardDie(PlayableCard card, CardSlot deathSlot, bool fromCombat, PlayableCard killer)
        {
            slot = deathSlot;
            return base.OnOtherCardDie(card, deathSlot, fromCombat, killer);
        }

    }
}