using DiskCardGame;
using InscryptionAPI.Card;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

namespace CoolMod;

public partial class Plugin
{
    private void Add_FireAnt()
    {
        AbilityInfo campfire = AbilityManager.New(PluginGuid, "Campfire", $"While [creature] is on the field, fire counts as an ant", typeof(Campfire), "Campfire.png")
        .SetPixelAbilityIcon(Asset.LoadTexture("CampfirePixel.png"))
        .SetDefaultPart1Ability()
        ;
        CardManager.New(modPrefix: PluginGuid, "FireAnt", "Fire Ant", 0, 1, "The fire warmed the weary ant and enhanced its power.")
            .SetDefaultPart3Card()
            .SetPortrait(Asset.LoadTexture("portrait_fireant.png"))
            .SetEmissivePortrait(Asset.LoadTexture("FireAntEmission.png"))
            .AddAbilities(campfire.ability)
            .SetPixelPortrait(Asset.LoadTexture("FireAnt.png"))
            .SetGBCPlayable(CardTemple.Nature)
            .SetBloodCost(1)
            .SetSpecialAbilities(SpecialTriggeredAbility.Ant)
            .SetStatIcon(SpecialStatIcon.Ants)
            .AddTribes(Tribe.Insect)
            .SetTraits(Trait.Ant);

            ;
    }
    public class Campfire : AbilityBehaviour
    {
        public override Ability Ability => Ability;
        public override bool RespondsToResolveOnBoard() => true;
        public override bool RespondsToOtherCardResolve(PlayableCard otherCard) => true;
        public override bool RespondsToDie(bool wasSacrifice, PlayableCard killer) => true;
        public Ability flammable = Molotov.ability;
        public override IEnumerator OnResolveOnBoard()
        {
            for (int i = 0; i < BoardManager.Instance.playerSlots.Count; i++)
            {
                if (BoardManager.Instance.playerSlots[i].Card != null && Card.OnBoard)
                {
                    if (BoardManager.Instance.playerSlots[i].Card.Info.displayedName == "Fire")
                    {
                        BoardManager.Instance.playerSlots[i].Card.Info.SetTraits(Trait.Terrain, Trait.Ant);
                    }
                }
            }
            yield return base.OnResolveOnBoard();
        }
        public override IEnumerator OnOtherCardResolve(PlayableCard otherCard)
        {
            for (int i = 0; i < BoardManager.Instance.playerSlots.Count; i++)
            {
                if (BoardManager.Instance.playerSlots[i].Card != null && Card.OnBoard)
                {
                    if (BoardManager.Instance.playerSlots[i].Card.Info.displayedName == "Fire")
                    {
                        BoardManager.Instance.playerSlots[i].Card.Info.SetTraits(Trait.Terrain, Trait.Ant);
                    }
                }
            }
            return base.OnOtherCardResolve(otherCard);
        }
        public override IEnumerator OnDie(bool wasSacrifice, PlayableCard killer)
        {
            for (int i = 0; i < BoardManager.Instance.playerSlots.Count; i++)
            {
                if (BoardManager.Instance.playerSlots[i].Card != null && Card.OnBoard)
                {
                    if (BoardManager.Instance.playerSlots[i].Card.Info.displayedName == "Fire" && BoardManager.Instance.playerSlots[i].Card.HasTrait(Trait.Ant))
                    {
                        BoardManager.Instance.playerSlots[i].Card.Info.SetTraits(Trait.Terrain);
                    }
                }
            }
            return base.OnDie(wasSacrifice, killer);
        }
    }
}