using DiskCardGame;
using GBC;
using InscryptionAPI.Card;
using InscryptionAPI.Triggers;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

namespace CoolMod;

public partial class Plugin
{
    private void Add_GemSiphon()
    {
        AbilityInfo gemmutant = AbilityManager.New(PluginGuid, "Gem Mutant", $"all creatures on [creature]s side of the board gain one power, and take one damage at the start of each turn.", typeof(GemsSiphon), "Mutations.png")
        .SetPixelAbilityIcon(Asset.LoadTexture("MutationsPixel.png"))
        ;
        CardManager.New(modPrefix: PluginGuid3, "StarvingMage", "Mutationer", 0, 1, "")
            .SetDefaultPart3Card()
            .SetPortrait(Asset.LoadTexture("ZombieHorde.png"))
            .SetEmissivePortrait(Asset.LoadTexture("ZombieHordeEmission.png"))
            .AddAbilities(gemmutant.ability, Ability.GemDependant)
            .SetPixelPortrait(Asset.LoadTexture("Mutationer.png"))
            .SetGBCPlayable(CardTemple.Wizard)
            .AddMetaCategories(CardMetaCategory.ChoiceNode, CardMetaCategory.TraderOffer)
            .SetCost(gemsCost: new List<GemType> { GemType.Green })
            .AddMetaCategories(CardMetaCategory.GBCPack)
            ;
    }
    public class GemsSiphon : AbilityBehaviour, IPassiveAttackBuff
    {
        public override Ability Ability => Ability;
        public override bool RespondsToUpkeep(bool playerUpkeep) => true;
        public int GetPassiveAttackBuff(PlayableCard target) => Card.OnBoard && target.IsPlayerCard() ? 1 : 0;
        public override IEnumerator OnUpkeep(bool playerUpkeep)
        {
            if (!playerUpkeep)
            {
                yield return Singleton<TextBox>.Instance.ShowUntilInput(Card.Info.displayedName + " had nasty aftereffects!", TextBox.Style.Neutral);
                if (BoardManager.Instance.playerSlots[0].Card != null && Card.slot != BoardManager.Instance.playerSlots[0])
                {
                    yield return BoardManager.Instance.playerSlots[0].Card.TakeDamage(1, Card);
                }
                if (BoardManager.Instance.playerSlots[1].Card != null && Card.slot != BoardManager.Instance.playerSlots[1])
                {
                    yield return BoardManager.Instance.playerSlots[1].Card.TakeDamage(1, Card);
                }
                if (BoardManager.Instance.playerSlots[2].Card != null && Card.slot != BoardManager.Instance.playerSlots[2])
                {
                    yield return BoardManager.Instance.playerSlots[2].Card.TakeDamage(1, Card);
                }
                if (BoardManager.Instance.playerSlots[3].Card != null && Card.slot != BoardManager.Instance.playerSlots[3])
                {
                    yield return BoardManager.Instance.playerSlots[3].Card.TakeDamage(1, Card);
                }
            }
            yield return base.OnUpkeep(playerUpkeep);
        }
    }
}