using DiskCardGame;
using InscryptionAPI.Card;
using System.Collections;

namespace CoolMod;

public partial class Plugin
{
    private void Add_Guts()
    {
        AbilityInfo guts = AbilityManager.New(PluginGuid, "Exploding Corpse", $"When [creature] perishes, fill all empty spaces with Guts", typeof(ExplodingCorpse), "HordeStrike.png")
        .SetPixelAbilityIcon(Asset.LoadTexture("ExplodingCorpsePixel.png"))
        ;
        CardManager.New(modPrefix: PluginGuid2, "Guts", "Guts", 0, 1, " ")
            .SetPortrait(Asset.LoadTexture("Guts.png"))
            .SetEmissivePortrait(Asset.LoadTexture("GutsEmission.png"))
            .AddAbilities()
            .SetPixelPortrait(Asset.LoadTexture("GutsPixel.png"))
        ;
        CardInfo cardInfo = CardManager.New(modPrefix: PluginGuid2, "GrimoraMod_BloatedBody", "Bloated Body", 1, 1, "Grotesque, this old body could blow at any moment.")
            .SetPortrait(Asset.LoadTexture("BloatedBody.png"))
            .SetEmissivePortrait(Asset.LoadTexture("BloatedBodyEmission.png"))
            .AddAbilities(guts.ability)
            .SetPixelPortrait(Asset.LoadTexture("BloatedBodyPixel.png"))
            .SetGBCPlayable(CardTemple.Undead)
            .SetBonesCost(4)
        ;
        CardManager.Add("arackulele.inscryption.grimoramod", cardInfo);
    }
    public class ExplodingCorpse : AbilityBehaviour
    {
        public override Ability Ability => Ability;
        public override bool RespondsToDie(bool wasSacrifice, PlayableCard killer) => true;
        public override IEnumerator OnDie(bool wasSacrifice, PlayableCard killer)
        {
            {
                if (BoardManager.Instance.playerSlots[0].Card == null)
                {
                    yield return BoardManager.Instance.CreateCardInSlot(CardLoader.GetCardByName($"{PluginGuid}_Guts"), BoardManager.Instance.playerSlots[0]);
                }
                if (BoardManager.Instance.playerSlots[1].Card == null)
                {
                    yield return BoardManager.Instance.CreateCardInSlot(CardLoader.GetCardByName($"{PluginGuid}_Guts"), BoardManager.Instance.playerSlots[1]);
                }
                if (BoardManager.Instance.playerSlots[2].Card == null)
                {
                    yield return BoardManager.Instance.CreateCardInSlot(CardLoader.GetCardByName($"{PluginGuid}_Guts"), BoardManager.Instance.playerSlots[2]);
                }
                if (BoardManager.Instance.playerSlots[3].Card == null)
                {
                    yield return BoardManager.Instance.CreateCardInSlot(CardLoader.GetCardByName($"{PluginGuid}_Guts"), BoardManager.Instance.playerSlots[3]);
                }
                if (BoardManager.Instance.opponentSlots[0].Card == null)
                {
                    yield return BoardManager.Instance.CreateCardInSlot(CardLoader.GetCardByName($"{PluginGuid}_Guts"), BoardManager.Instance.opponentSlots[0]);
                }
                if (BoardManager.Instance.opponentSlots[1].Card == null)
                {
                    yield return BoardManager.Instance.CreateCardInSlot(CardLoader.GetCardByName($"{PluginGuid}_Guts"), BoardManager.Instance.opponentSlots[1]);
                }
                if (BoardManager.Instance.opponentSlots[2].Card == null)
                {
                    yield return BoardManager.Instance.CreateCardInSlot(CardLoader.GetCardByName($"{PluginGuid}_Guts"), BoardManager.Instance.opponentSlots[2]);
                }
                if (BoardManager.Instance.opponentSlots[3].Card == null)
                {
                    yield return BoardManager.Instance.CreateCardInSlot(CardLoader.GetCardByName($"{PluginGuid}_Guts"), BoardManager.Instance.opponentSlots[3]);
                }
                yield return base.OnDie(wasSacrifice, killer);
            }
        }
    }
}