using DiskCardGame;
using HarmonyLib;
using InscryptionAPI.Card;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

namespace CoolMod;

public partial class Plugin
{
    private void Add_HouseMouse()
    {
        AbilityInfo mouse = AbilityManager.New(PluginGuid, "Crawler", $"[creature] will always be in your starting hand.", typeof(HouseMouse), "Crawler.png")
        .SetPixelAbilityIcon(Asset.LoadTexture("CrawlerPixel.png"))
        .SetDefaultPart1Ability()
        ;
        HouseMouse.ability = mouse.ability;
        mouse.SetPassive(true);
        CardManager.New(modPrefix: PluginGuid, "HouseMouse", "House Mouse", 1, 2, "The Persistent House Mouse, always at the top of your deck.")
            .SetDefaultPart3Card()
            .SetPortrait(Asset.LoadTexture("HouseMouse.png"))
            .SetEmissivePortrait(Asset.LoadTexture("HouseMouseEmission.png"))
            .AddAbilities(mouse.ability)
            .SetPixelPortrait(Asset.LoadTexture("HouseMousePixel.png"))
            .SetGBCPlayable(CardTemple.Nature)
            .SetBloodCost(1)
            ;
    }
    public class HouseMouse : AbilityBehaviour
    {
        internal static Ability ability;
        public override Ability Ability => ability;

    }

    [HarmonyPatch(typeof(BoardManager), "Initialize")]
    [HarmonyPostfix]
    public static void HouseMoused()
    {
     Singleton<CardDrawPiles>.Instance.StartCoroutine(mouse());
        IEnumerator mouse()
        {

            List<CardInfo> mousespawns = new List<CardInfo>();
            Debug.Log("log");
            yield return new WaitForSeconds(1);
            for(int i = 0; i < Singleton<CardDrawPiles>.Instance.Deck.cards.Count; i++)
            {
                Debug.Log("counting " + i);
                if (Singleton<CardDrawPiles>.Instance.Deck.cards[i].HasAbility(HouseMouse.ability))
                {
                    mousespawns.Add(Singleton<CardDrawPiles>.Instance.Deck.cards[i]);
                    Debug.Log("moused");
                }
            }
            for(int i = 0; i < mousespawns.Count; i++)
            {
                yield return Singleton<CardDrawPiles>.Instance.Deck.Cards.Remove(mousespawns[i]);
                yield return Singleton<CardSpawner>.Instance.SpawnCardToHand(mousespawns[i]);
                Debug.Log("mousedspawned");
            }
            Debug.Log("log2");
        }
    }
    [HarmonyPatch(typeof(BoardManager3D), "Initialize")]
    [HarmonyPostfix]
    public static void HouseMoused3D()
    {
        Singleton<CardDrawPiles>.Instance.StartCoroutine(mouse());
        IEnumerator mouse()
        {

            List<CardInfo> mousespawns = new List<CardInfo>();
            Debug.Log("log");
            yield return new WaitForSeconds(1);
            for (int i = 0; i < Singleton<CardDrawPiles>.Instance.Deck.cards.Count; i++)
            {
                Debug.Log("counting " + i);
                if (Singleton<CardDrawPiles>.Instance.Deck.cards[i].HasAbility(HouseMouse.ability))
                {
                    mousespawns.Add(Singleton<CardDrawPiles>.Instance.Deck.cards[i]);
                    Debug.Log("moused");
                }
            }
            for (int i = 0; i < mousespawns.Count; i++)
            {
                yield return Singleton<CardDrawPiles>.Instance.Deck.Cards.Remove(mousespawns[i]);
                yield return Singleton<CardSpawner>.Instance.SpawnCardToHand(mousespawns[i]);
                Debug.Log("mousedspawned");
            }

            Debug.Log("log2");
        }
    }

}