using BepInEx;
using DiskCardGame;
using InscryptionAPI.Card;
using InscryptionAPI.Helpers;
using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Reflection;
using UnityEngine;
using Object = UnityEngine.Object;

namespace CoolMod;

public partial class Plugin
{

    private void Add_LeepbotNeo()
    {
        AbilityInfo LeepbotNeo = AbilityManager.New(PluginGuid, "Hopper", $"at the end of your turn, [creature] will move to another space of your choice.", typeof(Hopper), "banding.png")
        .SetPixelAbilityIcon(Asset.LoadTexture("hopperPixel.png"))
        ;
        CardManager.New(modPrefix: PluginGuid4, "LeepbotNeo", "L33pB0t NEO", 2, 4, "")
            .SetDefaultPart3Card()
            .SetPortrait(Asset.LoadTexture("L33pbotNEO.png"))
            .SetEmissivePortrait(Asset.LoadTexture("L33pbotNEO.png"))
            .AddAbilities(LeepbotNeo.ability, Ability.Reach)
            .SetPixelPortrait(Asset.LoadTexture("L33pbotNEOPixel.png"))
            .SetGBCPlayable(CardTemple.Tech)
            .SetEnergyCost(6)
            .AddMetaCategories(TechRegion)
            .SetRare()
            ;
    }
    public class Hopper : AbilityBehaviour
    {
        public override Ability Ability => Ability;
        List<CardSlot> emptyslots = new List<CardSlot>();
        public override bool RespondsToUpkeep(bool playerUpkeep)
        {
            if (!playerUpkeep) { return true; } else { return false; }
        }
        public override IEnumerator OnUpkeep(bool playerUpkeep)
        {
            List<CardSlot> emptyslots = new List<CardSlot>();
            for(int i = 0; i < BoardManager.Instance.playerSlots.Count; i++)
            {
                if (BoardManager.Instance.playerSlots[i].Card == null)
                {
                    emptyslots.Add(BoardManager.Instance.playerSlots[i]);
                }
            }
            Action<CardSlot> healer = i => this.StartCoroutine(heal(i));
            Func<bool> result = new Func<bool>(() => false);
            IEnumerator heal(CardSlot cardslot)
            {
                if (cardslot.Card == null)
                {
                    yield return BoardManager.Instance.AssignCardToSlot(Card, cardslot);
                }
                yield return null;
            }
            yield return Singleton<BoardManager>.Instance.ChooseTarget(emptyslots, emptyslots, healer, null, null, result, CursorType.Target);
            yield break;
        }
    }
}