using DiskCardGame;
using GBC;
using InscryptionAPI.Card;
using System.Collections;
using UnityEngine;

namespace CoolMod;

public partial class Plugin
{
    private void Add_LochNess()
    {
        AbilityInfo Unstoppable = AbilityManager.New(PluginGuid, "Unstoppable", $"when [creature] deals overkill damage, that overkill is added to the scales.", typeof(Trample), "Unstoppable.png")
        .SetPixelAbilityIcon(Asset.LoadTexture("UnstoppablePixel.png"))
        .SetDefaultPart1Ability()
        ;
        CardManager.New(modPrefix: PluginGuid, "LochNess", "Loch Ness Monster", 4, 2, "Ever elusive, and ever destructive, the Monster of Loch Ness is.")
            .SetDefaultPart3Card()
            .SetPortrait(Asset.LoadTexture("portrait_Nessie.png"))
            .SetEmissivePortrait(Asset.LoadTexture("NessieEmission.png"))
            .AddAbilities(Unstoppable.ability, Ability.Submerge)
            .SetPixelPortrait(Asset.LoadTexture("Nessie.png"))
            .SetGBCPlayable(CardTemple.Nature)
            .SetBloodCost(3)
            .SetRare();
            ;
    }
    public class Trample : AbilityBehaviour
    {
        public override Ability Ability => Ability;
        public override bool RespondsToDealDamage(int amount, PlayableCard target) => true;
        public override IEnumerator OnDealDamage(int amount, PlayableCard target)
        {
            if (amount - target.Info.Health > 0 && !target.InOpponentQueue)
            {
                yield return Singleton<LifeManager>.Instance.ShowDamageSequence(amount - target.Info.Health, amount - target.Info.Health, base.Card.OpponentCard);
                if (Singleton<PixelScales>.Instance != null)
                {
                    yield return Singleton<TextBox>.Instance.ShowUntilInput(Card.Info.displayedName + "'s overkill was added to the scale!", TextBox.Style.Neutral);
                }
            }
            yield return base.OnDealDamage(amount, target);
        }
    }
}