using DiskCardGame;
using GBC;
using InscryptionAPI.Card;
using InscryptionAPI.Triggers;
using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

namespace CoolMod;

public partial class Plugin
{
    private void Add_MellifiedMan()
    {
        Texture2D tex = Asset.LoadTexture("DeliciousMealPixel.png");
        Sprite texSprite1 = Sprite.Create(tex, new Rect(0.0f, 0.0f, tex.width, tex.height), new Vector2(0.5f, 0.5f), 100.0f);

        AbilityInfo delicious = AbilityManager.New(
        PluginGuid,
        "Delicious",
        "deal 1 damage to [creature] to give another card 3 health.",
        typeof(Tasty),
        Asset.LoadTexture("DeliciousMeal.png")
    );
        delicious.pixelIcon = texSprite1;
        delicious.powerLevel = 4;
        delicious.activated = true;

        Tasty.ability = delicious.ability;
        CardInfo cardInfo = CardManager.New(modPrefix: PluginGuid2, "GrimoraMod_MellifiedMan", "Mellified Man", 0, 3, "Sickly-sweet, why not take a bite?")
            .SetDefaultPart3Card()
            .SetPortrait(Asset.LoadTexture("MellifiedMan.png"))
            .SetEmissivePortrait(Asset.LoadTexture("MellifiedMan_Emission.png"))
            .AddAbilities(delicious.ability)
            .SetPixelPortrait(Asset.LoadTexture("MellifiedManPixel.png"))
            .SetGBCPlayable(CardTemple.Undead)
            .SetBonesCost(3)
            .SetRare()
            ;
        CardManager.Add("arackulele.inscryption.grimoramod", cardInfo);
    }
    public class Tasty : ExtendedActivatedAbilityBehaviour
    {
        List<CardSlot> emptyslots = new List<CardSlot>();
        internal static Ability ability;
        public override Ability Ability => ability;
        public override int StartingHealthCost => 1;
        public override bool CanActivate() => true;
        public override IEnumerator Activate()
        {
            List<CardSlot> emptyslots = new List<CardSlot>();
            for (int i = 0; i < BoardManager.Instance.allSlots.Count; i++)
            {
                if (BoardManager.Instance.allSlots[i].Card != null)
                {
                    if (BoardManager.Instance.allSlots[i].Card != Card)
                    {
                        emptyslots.Add(BoardManager.Instance.allSlots[i]);
                    }
                }
            }
            Debug.Log("pressed");
            Action<CardSlot> healer = i => this.StartCoroutine(heal(i));
            Func<bool> result = new Func<bool>(() => false);
            IEnumerator heal(CardSlot cardslot)
            {
                if (cardslot.Card != null)
                {
                    cardslot.Card.AddTemporaryMod(Healer);
                }
                Debug.Log(cardslot);
                yield break;
            }
            if (emptyslots.Count > 0)
            {
                yield return Singleton<BoardManager>.Instance.ChooseTarget(emptyslots, emptyslots, healer, null, null, result, CursorType.Target);
            }
            yield break;
        }
        public CardModificationInfo Healer
        {
            get
            {
                CardModificationInfo info = new CardModificationInfo() { healthAdjustment = 3};
                return info;

            }

        }
    }
}