using DiskCardGame;
using GBC;
using InscryptionAPI.Card;
using InscryptionAPI.Triggers;
using System.Collections;
using UnityEngine;

namespace CoolMod;

public partial class Plugin
{
    private void Add_RebootConduit()
    {
        Texture2D tex = Asset.LoadTexture("Rebootpixel.png");
        Sprite texSprite1 = Sprite.Create(tex, new Rect(0.0f, 0.0f, tex.width, tex.height), new Vector2(0.5f, 0.5f), 100.0f);

        AbilityInfo reboot = AbilityManager.New(
        PluginGuid,
        "Reboot",
        "pay 3 energy to activate all on death or on play sigils within the circuit.",
        typeof(Rebooter),
        Asset.LoadTexture("RebootConduitAbility.png")
    );
        reboot.pixelIcon = texSprite1;
        reboot.powerLevel = 4;
        reboot.activated = true;
        reboot.conduit = true;

        Rebooter.ability = reboot.ability;
        CardManager.New(modPrefix: PluginGuid4, "RebootConduit", "Reboot Conduit", 0, 1, "")
            .SetDefaultPart3Card()
            .SetPortrait(Asset.LoadTexture("RebootConduit.png"))
            .SetEmissivePortrait(Asset.LoadTexture("RebootConduit.png"))
            .AddAbilities(reboot.ability)
            .SetPixelPortrait(Asset.LoadTexture("pixelportrait_reboot.png"))
            .SetGBCPlayable(CardTemple.Tech)
            .SetEnergyCost(3)
            .AddMetaCategories(TechRegion)
            ;
    }
    public class Rebooter : ExtendedActivatedAbilityBehaviour
    {
        internal static Ability ability;
        public override Ability Ability => ability;
        public override int StartingEnergyCost => 3;
        public override bool CanActivate() => true;
        public PlayableCard card2 = null;
        public override IEnumerator Activate()
        {
            for (int i = 0; i < BoardManager.Instance.PlayerSlotsCopy.Count; i++)
            {
                if (BoardManager.Instance.PlayerSlotsCopy[i].Card != null && BoardManager.Instance.PlayerSlotsCopy[i] != Card.slot && BoardManager.Instance.PlayerSlotsCopy[i].WithinConduitCircuit)
                {
                    yield return new WaitForSeconds(0.1f);
                    card2 = BoardManager.Instance.PlayerSlotsCopy[i].Card;
                    yield return BoardManager.Instance.PlayerSlotsCopy[i].Card.TakeDamage(44, null);
                    yield return new WaitForSeconds(0.05f);
                    Debug.Log(card2);
                    yield return BoardManager.Instance.CreateCardInSlot(card2.Info, card2.slot);
                    yield return ResourcesManager.Instance.SpendBones(1);
                }
            }
            yield break;
        }
    }
}