using DiskCardGame;
using InscryptionAPI.Card;
using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

namespace CoolMod;

public partial class Plugin
{
    private void Add_Shady()
    {
        Texture2D tex = Asset.LoadTexture("bargainspixel.png");
        Sprite texSprite1 = Sprite.Create(tex, new Rect(0.0f, 0.0f, tex.width, tex.height), new Vector2(0.5f, 0.5f), 100.0f);

        AbilityInfo trade = AbilityManager.New(
        PluginGuid,
        "GemTrade",
        "Sacrifice a gem to create a different colored gem in your hand.",
        typeof(GemTrade),
        Asset.LoadTexture("bargains.png")
    );
        trade.pixelIcon = texSprite1;
        trade.powerLevel = 4;
        trade.activated = true;

        GemTrade.ability = trade.ability;

        CardManager.New(modPrefix: PluginGuid3, "ShadyMerchant", "Shady Merchant", 1, 1, "")
            .SetPortrait(Asset.LoadTexture("portrait_fire.png"))
            .SetEmissivePortrait(Asset.LoadTexture("portrait_fire.png"))
            .AddAbilities(trade.ability)
            .SetPixelPortrait(Asset.LoadTexture("shadymerchnat.png"))
            .SetGBCPlayable(CardTemple.Wizard)
            .SetGemsCost(GemType.Blue)
            ;
    }
    public class GemTrade : ExtendedActivatedAbilityBehaviour
    {
        List<CardSlot> emptyslots = new List<CardSlot>();
        internal static Ability ability;
        public override Ability Ability => ability;
        public override bool CanActivate() => true;
        public override IEnumerator Activate()
        {
            List<CardSlot> emptyslots = new List<CardSlot>();
            for (int i = 0; i < BoardManager.Instance.playerSlots.Count; i++)
            {
                if (BoardManager.Instance.allSlots[i].Card != null)
                {
                    if (BoardManager.Instance.allSlots[i].Card.HasTrait(Trait.Gem))
                    {
                        emptyslots.Add(BoardManager.Instance.allSlots[i]);
                    }
                }
            }
            Debug.Log("pressed");
            Action<CardSlot> healer = i => this.StartCoroutine(heal(i));
            Func<bool> result = new Func<bool>(() => false);
            IEnumerator heal(CardSlot cardslot)
            {
                if (cardslot.Card != null)
                {
                    if (cardslot.Card.HasAbility(Ability.GainGemOrange)) {
                        if (cardslot.Card.HasAbility(Ability.GainGemBlue))
                        {
                            if (cardslot.Card.HasAbility(Ability.GainGemGreen))
                            {
                                yield return Singleton<CardSpawner>.Instance.SpawnCardToHand(CardLoader.GetCardByName("MoxRuby"));
                            }
                            else
                            {
                                yield return Singleton<CardSpawner>.Instance.SpawnCardToHand(CardLoader.GetCardByName("MoxEmerald"));
                            }
                        }
                        else
                        {
                            yield return Singleton<CardSpawner>.Instance.SpawnCardToHand(CardLoader.GetCardByName("MoxEmerald"));
                        }
                    } 
                    else{
                        yield return Singleton<CardSpawner>.Instance.SpawnCardToHand(CardLoader.GetCardByName("MoxRuby"));
                    }
                }
                yield return cardslot.Card.TakeDamage(222, null);
                Debug.Log(cardslot);
                yield break;
            }
            if (emptyslots.Count > 0)
            {
                yield return Singleton<BoardManager>.Instance.ChooseTarget(emptyslots, emptyslots, healer, null, null, result, CursorType.Target);
            }
            yield break;
        }
    }
}