using DiskCardGame;
using InscryptionAPI.Card;
using System.Collections;
using System.Collections.Generic;

namespace CoolMod;

public partial class Plugin
{
    private void Add_SicklyQueen()
    {
        AbilityInfo giftbearer = AbilityManager.New(PluginGuid, "Gift Bearer", $"When [creature] perishes, a random creature is created in your hand.", typeof(DrawRandomAlt), "Rolling.png")
        .SetPixelAbilityIcon(Asset.LoadTexture("GiftBearerPixel.png"))
        ;
        CardInfo cardInfo = CardManager.New(modPrefix: PluginGuid2, "GrimoraMod_SicklyQueen", "Sickly Queen", 0, 1, "Once thought immortal, this fallen monarch.")
            .SetPortrait(Asset.LoadTexture("SicklyQueen.png"))
            .SetEmissivePortrait(Asset.LoadTexture("SicklyQueenEmission.png"))
            .AddAbilities(giftbearer.ability, Ability.DrawCopyOnDeath)
            .SetPixelPortrait(Asset.LoadTexture("SicklyQueenPixel.png"))
            .SetGBCPlayable(CardTemple.Undead)
            .SetBonesCost(4)
            .SetRare();
            ;
        CardManager.Add("arackulele.inscryption.grimoramod", cardInfo);
    }
    public class DrawRandomAlt : AbilityBehaviour
    {
        public override Ability Ability => Ability;
        public override bool RespondsToDie(bool wasSacrifice, PlayableCard killer) => true;
        public int seed = 234;
        List<CardInfo> cards = new List<CardInfo>();
        public override IEnumerator OnDie(bool wasSacrifice, PlayableCard killer)

        {
            randomize();
            yield return CardSpawner.Instance.SpawnCardToHand(cards[SeededRandom.Range(0, cards.Count, GetRandomSeed())]);
        }
        void randomize()
        {
            seed++;
            cards.Clear();
            for (int i = 0; i < CardLoader.GetPixelCards().Count; i++)
            {
                if (CardLoader.GetPixelCards()[i].temple == CardTemple.Undead)
                {
                    cards.Add(CardLoader.GetPixelCards()[i]);
                }
            }
        }
    }
}