using DiskCardGame;
using InscryptionAPI.Card;
using InscryptionAPI.Triggers;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

namespace CoolMod;

public partial class Plugin
{
    private void Add_ZombieHorde()
    {
        AbilityInfo hordestrike = AbilityManager.New(PluginGuid, "Horde Strike", $"[creature] attacks for as many zombies the owner of [creature] controls", typeof(HordeStrike), "HordeStrike.png")
        .SetPixelAbilityIcon(Asset.LoadTexture("HordeStrikePixel.png"))
        ;
        CardInfo cardInfo = CardManager.New(modPrefix: PluginGuid2, "GrimoraMod_ZombieHorde", "Zombie Horde", 1, 2, "Their countless numbers ever-rising, this swarm moves as one.")
            .SetPortrait(Asset.LoadTexture("ZombieHorde.png"))
            .SetEmissivePortrait(Asset.LoadTexture("ZombieHordeEmission.png"))
            .AddAbilities(hordestrike.ability)
            .SetPixelPortrait(Asset.LoadTexture("ZombieHordePixel.png"))
            .SetGBCPlayable(CardTemple.Undead)
            .AddMetaCategories(CardMetaCategory.ChoiceNode, CardMetaCategory.TraderOffer)
            .SetBonesCost(4)
            .AddMetaCategories(CardMetaCategory.GBCPack)
            ;
        CardManager.Add("arackulele.inscryption.grimoramod", cardInfo);
    }
    public class HordeStrike : ExtendedAbilityBehaviour, IGetOpposingSlots
    {
        internal static Ability ability;
        public override Ability Ability => ability;
        public List<CardSlot> hitslots = new List<CardSlot> {};
        public override bool RespondsToOtherCardResolve(PlayableCard otherCard) => true;
        public override bool RespondsToOtherCardDie(PlayableCard card, CardSlot deathSlot, bool fromCombat, PlayableCard killer) => true;
        public override bool RespondsToResolveOnBoard() => true;
        public List<CardSlot> GetOpposingSlots(List<CardSlot> originalSlots, List<CardSlot> otherAddedSlots) => hitslots;
        public bool RemoveDefaultAttackSlot() => true;
        public bool RespondsToGetOpposingSlots() => true;
        public override IEnumerator OnOtherCardResolve(PlayableCard otherCard)
        {
            hitslots.Clear();
            if (Card.IsPlayerCard())
            {
                for (int i = 0; i < BoardManager.Instance.playerSlots.Count; i++)
                {
                    if (BoardManager.Instance.playerSlots[i].Card != null)
                    {
                        if (BoardManager.Instance.playerSlots[i].Card.name == Card.name)
                        {
                            hitslots.Add(Card.OpposingSlot());
                        }
                    }
                }
                for (int i = 0; i < BoardManager.Instance.playerSlots.Count; i++)
                {
                    if (BoardManager.Instance.playerSlots[i].Card != null)
                    {
                        if (BoardManager.Instance.playerSlots[i].Card.Info.name == "Zombie")
                        {
                            hitslots.Add(Card.OpposingSlot());
                        }
                    }
                }
            }
            if (!Card.IsPlayerCard())
            {
                for (int i = 0; i < BoardManager.Instance.opponentSlots.Count; i++)
                {
                    if (BoardManager.Instance.opponentSlots[i].Card != null)
                    {
                        if (BoardManager.Instance.opponentSlots[i].Card.name == Card.name)
                        {
                            hitslots.Add(Card.OpposingSlot());
                        }
                    }
                }
                for (int i = 0; i < BoardManager.Instance.opponentSlots.Count; i++)
                {
                    if (BoardManager.Instance.opponentSlots[i].Card != null)
                    {
                        if (BoardManager.Instance.opponentSlots[i].Card.Info.name == "Zombie")
                        {
                            hitslots.Add(Card.OpposingSlot());
                        }
                    }
                }
            }
            yield return base.OnOtherCardResolve(otherCard);
        }
        public override IEnumerator OnOtherCardDie(PlayableCard card, CardSlot deathSlot, bool fromCombat, PlayableCard killer)
        {
            hitslots.Clear();
            if (Card.IsPlayerCard())
            {
                for (int i = 0; i < BoardManager.Instance.playerSlots.Count; i++)
                {
                    if (BoardManager.Instance.playerSlots[i].Card != null)
                    {
                        if (BoardManager.Instance.playerSlots[i].Card.name == Card.name)
                        {
                            hitslots.Add(Card.OpposingSlot());
                        }
                    }
                }
                for (int i = 0; i < BoardManager.Instance.playerSlots.Count; i++)
                {
                    if (BoardManager.Instance.playerSlots[i].Card != null)
                    {
                        if (BoardManager.Instance.playerSlots[i].Card.Info.name == "Zombie")
                        {
                            hitslots.Add(Card.OpposingSlot());
                        }
                    }
                }
            }
            if (!Card.IsPlayerCard())
            {
                for (int i = 0; i < BoardManager.Instance.opponentSlots.Count; i++)
                {
                    if (BoardManager.Instance.opponentSlots[i].Card != null)
                    {
                        if (BoardManager.Instance.opponentSlots[i].Card.name == Card.name)
                        {
                            hitslots.Add(Card.OpposingSlot());
                        }
                    }
                }
                for (int i = 0; i < BoardManager.Instance.opponentSlots.Count; i++)
                {
                    if (BoardManager.Instance.opponentSlots[i].Card != null)
                    {
                        if (BoardManager.Instance.opponentSlots[i].Card.Info.name == "Zombie")
                        {
                            hitslots.Add(Card.OpposingSlot());
                        }
                    }
                }
            }
            yield return base.OnOtherCardDie(card, deathSlot, fromCombat, killer);
        }
        public override IEnumerator OnResolveOnBoard()
        {
            hitslots.Clear();
            if (Card.IsPlayerCard())
            {
                for (int i = 0; i < BoardManager.Instance.playerSlots.Count; i++)
                {
                    if (BoardManager.Instance.playerSlots[i].Card != null)
                    {
                        if (BoardManager.Instance.playerSlots[i].Card.name == Card.name)
                        {
                            hitslots.Add(Card.OpposingSlot());
                        }
                    }
                }
                for (int i = 0; i < BoardManager.Instance.playerSlots.Count; i++)
                {
                    if (BoardManager.Instance.playerSlots[i].Card != null)
                    {
                        if (BoardManager.Instance.playerSlots[i].Card.Info.name == "Zombie")
                        {
                            hitslots.Add(Card.OpposingSlot());
                        }
                    }
                }
            }
            if (!Card.IsPlayerCard())
            {
                for (int i = 0; i < BoardManager.Instance.opponentSlots.Count; i++)
                {
                    if (BoardManager.Instance.opponentSlots[i].Card != null)
                    {
                        if (BoardManager.Instance.opponentSlots[i].Card.name == Card.name)
                        {
                            hitslots.Add(Card.OpposingSlot());
                        }
                    }
                }
                for (int i = 0; i < BoardManager.Instance.opponentSlots.Count; i++)
                {
                    if (BoardManager.Instance.opponentSlots[i].Card != null)
                    {
                        if (BoardManager.Instance.opponentSlots[i].Card.Info.name == "Zombie")
                        {
                            hitslots.Add(Card.OpposingSlot());
                        }
                    }
                }
            }
            yield return base.OnResolveOnBoard();
        }
    }
}